;=============================================
; 145   / ""
;..  <alldn@yahoo.com>  2000.
;WDT OFF.   F_RC_osc=1.2 .
;   
; EEPROM
;  5 .
;=============================================
;
;
indf    equ     00  ;  
tmr0    equ     01  ;
pcl     equ     02  ; 
status  equ     03  ;  status
fsr     equ     04  ;  
;
port_a  equ     05  ; 
port_b  equ     06  ; 
;
EEData  equ     08h         ; EEPROM Data
EECon1  equ     08h         ; EECON1 - RP0=1
EEAdr   equ     09h         ; EEPROM Address
EECon2  equ     09h         ; EECON2 - RP0=1
IntCon  equ     0bh
;=============================================
;
;
count   equ     0Ch ;
count1  equ     0Dh ;
count2  equ     0Eh ;
rotate  equ     0Fh ; DATA
cross   equ     10h ; 
;
H_mulplr  equ   11h ;  16- 
L_mulplr  equ   12h ;  16- 
mulcnd   equ    13h ;8- 
;
R0      equ     14h ;
R1      equ     15h ;
R2      equ     16h ;
;
H_byte  equ     17h ; 
M_byte  equ     18h ; 
L_byte  equ     19h ;
;
rxhi    equ     1Ah ;
rxlo    equ     1Bh ;
;
txhi    equ     1Ch ;
txlo    equ     1Dh ;
;
H_begin equ     1Eh ;
L_begin equ     1Fh ;
;
H_end   equ     20h ;
L_end   equ     21h ;

param   equ     22h ; 
                    ; 
konf1   equ     23h ;
konf2   equ     24h ;
H_konf  equ     25h ;
M_konf  equ     26h ;
L_konf  equ     27h ;

step    equ     28h ; 
step4   equ     29h ;  
realst  equ     2Ah ; 
;
xtalhi  equ     2Bh ;
xtallo  equ     2Ch ; -
vcohi   equ     2Dh ;
vcolo   equ     2Eh ;VCO -
vcotmp  equ     2Fh ;
;=============================================
; 
RP0     equ     5
HStep   equ     5   ;  
;
;=============================================
;
        include <macro.mac>
;
;=============================================
        list p=16F84
       __CONFIG 03FF3H
;=============================================
        org     2100h
;---------------------------------------------
;  
;---------------------------------------------
;
f01   DE  002h,032h,080h ; ......144000
f1c   DE  070h,080h      ;144.000/5   
f02   DE  002h,03Ah,050h ;  ......146000
f2c   DE  072h,010h      ;146.000/5    
f03   DE  002h,037h,094h ; .....145300
f3c   DE  071h,084h      ;145.300/5    
f04   DE  002h,039h,06Fh ; ...145775
f4c   DE  071h,0E3h      ;145.775/5   
f05   DE  002h,032h,080h ; ..144000
f05c  DE  070h,080h      ;144.000/5   
f06   DE  002h,032h,080h ; ..144000
f06c  DE  070h,080h      ;144.000/5   
f07   DE  002h,032h,080h ; ..144000
f07c  DE  070h,080h      ;144.000/5   
f08   DE  002h,032h,080h ; ..144000
f08c  DE  070h,080h      ;144.000/5   
f09   DE  000h,029h,0CCh ; ..10700
f09c  DE  008h,05Ch      ;(10700/5)  /
f10   DE  000h,002h,058h ; .....600
f10c  DE  000h,078h      ;600/5
f11   DE  000h,000h,019h ; ...........25
f11c  DE  000h,005h      ;25/5
f12   DE  000h,01Fh,040h ;F  ....8000
f12c  DE  006h,040h      ;8000/5
;
;---------------------------------------------
        org     0
;---------------------------------------------
;  
;---------------------------------------------
;
cold      goto    start     ; 
b2_bcd    goto    transf    ; bin to BCD
dadd      goto    d_add     ; 24  16  
displ     goto    outbyt    ;   
divide    goto    div24     ; 24    8 
dsub      goto    d_sub     ; 24  16  
keyoff    goto    key_off   ;  
m16x8     goto    mul16x8   ; 16-   8-
maximum   goto    max       ;  
minimum   goto    min       ;  
minus100  goto    minus100k ; 100 
minus25   goto    minus25k  ;  
negative  goto    negat     ;  
plus100   goto    plus100k  ; 100 
plus25    goto    plus25k   ;  
read      goto    readm     ;   
replace0  goto    repl      ;  
retrans   goto    retr      ;/  
secoper   goto    sec_op    ;  
send      goto    sendbyt   ;    PL-
setfreq   goto    setfr     ;   PL-
sound     goto    pisk      ;  
wait      goto    wait1     ;
writepar  goto    wrtpar    ;   EEPROM
;
;=============================================
;************  *******************
;=============================================
;---------------------------------------------
;  24    8 
;   HML_byte / rotate => HML_byte
;---------------------------------------------
div24
        movlw   .24
        movwf   count
        clrf    count1
divloop
        bcf     3,0
        rlf     L_konf,f   ;24   
        rlf     M_konf,f   ;24   
        rlf     H_konf,f   ;24   
        rlf     count1,f
        movlw   HStep       ;8 
        subwf   count1,w
        btfss   3,0
        goto    nosub
        bsf     L_konf,0
        movlw   HStep       ;8 
        subwf   count1,f
nosub
        decfsz  count,f
        goto    divloop
        ret
;---------------------------------------------
;   
;---------------------------------------------
outbyt
        movwf   rotate    ;  W   rotate
        clrf    count     ; 8
        bsf     count,3   ;       .
        bcf     status,0    ; cary
displ1
        clrf    status
        rlf     rotate,f  ; rotate   C
        btfsc   status,0       ; Cary=0 skip
        bsf     port_b,5  ; DATA=1
        btfss   status,0       ; ary=1 skip
        bcf     port_b,5  ;. DATA=0
        nop
        bsf     port_b,4  ;CLK=1 _-
        nop
        bcf     port_b,4  ;   =0   -_  
        decfsz  count,f   ;  .
        goto    displ1    ;  0.  .
;
        ret               ;  \.
;
;---------------------------------------------
;/  
;---------------------------------------------
retr
        movf    cross,f ; ?
        jnz     init3   ;,  
        movlw   0xE0    ; 
        movwf   cross   ;
;
        movlw   LOW f4c
        call    read
        movwf   rxhi           ;
        movwf   M_byte
;                              ;
        movlw   LOW (f4c + 1)  ;
        call    read           ;
        movwf   rxlo           ;
        movwf   L_byte
;                        
        movlw   LOW f10c
        call    read
        movwf   H_mulplr
;
        movlw   LOW (f10c + 1)
        call    read
        movwf   L_mulplr

        call    dsub    ;-600/5

        movf    M_byte,w
        movwf   txhi           ;
        movf    L_byte,w
        movwf   txlo
;
        movf    rxhi,w
        movwf   M_byte
        movf    rxlo,w
        movwf   L_byte

;          
        call    secoper
;           
        call    dsub
;
        movf    M_byte,w
        movwf   rxhi           ;
        movf    L_byte,w
        movwf   rxlo
;
        ret               ;  \.
;
;---------------------------------------------
;    w
;---------------------------------------------
readm
        movwf   EEAdr
        bsf     status,RP0
        bsf     EECon1,0
        bcf     status,RP0
        movf    EEData,w
        ret               ;  \.
;---------------------------------------------
;  
;---------------------------------------------
plus25k
        movf    step,w
        addwf   rxlo,f
        jnc     pl1
        incf    rxhi,f
pl1
        movf    step,w
        addwf   txlo,f
        jnc     pl2
        incf    txhi,f
pl2
        call    maximum
        movf    H_byte,f
        jz      minus25k
        ret               ;  \.
;
;---------------------------------------------
;  
;---------------------------------------------
minus25k
        movf    step,w
        subwf   rxlo,f
        jc      min1
        decf    rxhi,f
min1
        movf    step,w
        subwf   txlo,f
        jc      min2
        decf    txhi,f
min2
        call    minimum
        movf    H_byte,f
        jz     plus25k

        ret               ;  \.
;
;---------------------------------------------
;  
;---------------------------------------------
plus100k
        movf    step4,w
        addwf   rxlo,f
        jnc     pl21
        incf    rxhi,f
pl21
        movf    step4,w
        addwf   txlo,f
        jnc     pl22
        incf    txhi,f
pl22
        call    maximum
        movf    H_byte,f
        jz      minus100k
        ret               ;  \.
;---------------------------------------------
;  
;---------------------------------------------
minus100k
        movf    step4,w
        subwf   rxlo,f
        jc      min21
        decf    rxhi,f
min21
        movf    step4,w
        subwf   txlo,f
        jc      min22
        decf    txhi,f
min22
        call    minimum
        movf    H_byte,f
        jz      plus100k
        ret               ;  \.
;---------------------------------------------
;  
;---------------------------------------------
pisk
        movlw   .50
        movwf   count
sound2
        bsf     port_b,6  ;_i-
;
; --------------------------------
        movlw   .10
        movwf   count1
sound1
        decfsz  count1,1    ; ~2ms
        goto    sound1
;
        bcf     port_b,6  ; -i_
;
; --------------------------------
        movlw   .10
        movwf   count1
sound11
        decfsz  count1,1    ; ~2ms
        goto    sound11
;
        decfsz  count,1
        goto    sound2
;
        ret               ;  \.
;---------------------------------------------
;   1015PL4
;---------------------------------------------
setfr
        movlw   LOW f12c
        call    read
        movwf   xtalhi         ;
;                              ; 
        movlw   LOW (f12c + 1) ;
        call    read           ;-
        movwf   xtallo
;
        movf    count1,w
        movwf   fsr           ;
        movf    0,w           ;
        movwf   vcohi         ;
                              ;VCO
        incf    count1,w      ;
        movwf   fsr           ;
        movf    0,w           ;
        movwf   vcolo         ;

        bcf     status,0      ;C <= 0

        rlf     vcolo,f
        rlf     vcohi,f
        rlf     xtallo,f
        rlf     xtalhi,f

        movf    vcolo,w
        andlw   0fh
        movwf   vcotmp
        bsf     vcotmp,0  ;7/8

        rlf     vcolo,f
        rlf     vcohi,f
        rlf     xtallo,f
        rlf     xtalhi,f

        rlf     vcolo,f
        rlf     vcohi,f
        rlf     xtallo,f
        rlf     xtalhi,f

        movlw   0C0h
        andwf   vcolo,f
        movf    vcotmp,w
        iorwf   vcolo,f

        movf    xtalhi,w   ;  10154
        call    send       ;1 
        movf    xtallo,w
        call    send       ;2 
        movf    vcohi,w
        call    send       ;3 
        movf    vcolo,w
        call    send       ;4 
strob
        bsf     port_a,2   ;1 _-
        nop
        bcf     port_a,2   ;0   -_
;
        ret               ;  \.
;---------------------------------------------
;   rotate   1015PL4
;---------------------------------------------
sendbyt
        movwf   rotate    ;  W   rotate
        clrf    count     ; 8
        bsf     count,3   ;       .
        bcf     3,0       ; cary
next
        rlf     rotate,f  ; rotate   C
        btfsc   3,0       ; Cary=0 skip
        bsf     port_a,0  ; DATA=1
        btfss   3,0       ; ary=1 skip
        bcf     port_a,0  ;. DATA=0
        nop
        bsf     port_a,1  ;CLK=1 _-
        nop
        bcf     port_a,1  ;   =0   -_  
        decfsz  count,1   ;  .
        goto    next      ;  0.  .

        ret               ;  \.
;---------------------------------------------
; BIN to BCD
;---------------------------------------------
;
transf
        bcf     status,0    ; clear the carry bit
        movlw   .24
        movwf   count
        clrf    R0
        clrf    R1
        clrf    R2
loop16  rlf     L_byte,f
        rlf     M_byte,f
        rlf     H_byte,f
        rlf     R2,f
        rlf     R1,f
        rlf     R0,f
;
        decfsz  count,f
        goto    adjDEC
;
;    0xA  LCD 
repl
        movlw   0x0F
        andwf   R2,0
        jnz     next1
        movlw   0x0A
        iorwf   R2,f
next1
        movlw   0xF0
        andwf   R2,0
        jnz     next2
        movlw   0xA0
        iorwf   R2,f
next2
        movlw   0x0F
        andwf   R1,0
        jnz     next3
        movlw   0x0A
        iorwf   R1,f
next3
        movlw   0xF0
        andwf   R1,0
        jnz     next4
        movlw   0xA0
        iorwf   R1,f
next4
        ret
;
adjDEC
        movlw   R2
        movwf   fsr
        call    adjBCD
;
        movlw   R1
        movwf   fsr
        call    adjBCD
;
        movlw   R0
        movwf   fsr
        call    adjBCD
;
        goto    loop16
;
adjBCD  movlw   3
        addwf   0,W
        movwf   count1
        btfsc   count1,3  ; test if result > 7
        movwf   0
        movlw   30
        addwf   0,W
        movwf   count1
        btfsc   count1,7  ; test if result > 7
        movwf   0         ; save as MSD
;
        ret
;---------------------------------------------
;  16-   8-
;---------------------------------------------
;
mul16x8
        clrf    H_byte
        clrf    M_byte
        clrf    L_byte
        movlw   .16
        movwf   count
        movf    mulcnd,w
        bcf     status,0    ; Clear the carry bit in the
loop                      ; status Reg.
        rrf     H_mulplr,f
        rrf     L_mulplr,f
        btfsc   status,0
        addwf   H_byte,f
        rrf     H_byte,f
        rrf     M_byte,f
        rrf     L_byte,f
        decfsz  count,f
        goto    loop
;
        ret
;---------------------------------------------
;   
;---------------------------------------------
;
max
        movf    H_end,w
        movwf   M_byte
        movf    L_end,w
        movwf   L_byte

        movf    cross,f  ;  ?
        jz      max1     ; 

        movlw   LOW f10c ; ,   
        call    read     ; 
        movwf   H_mulplr
;
        movlw   LOW (f10c + 1)
        call    read
        movwf   L_mulplr

        call    dsub
max1
        movlw   0
        movwf   H_byte

        movf    txhi,w
        movwf   H_mulplr
        movf    txlo,w
        movwf   L_mulplr
        goto    dsub
;
;---------------------------------------------
;   
;---------------------------------------------
;
min
        movlw   0
        movwf   H_byte
        movf    txhi,w
        movwf   M_byte
        movf    txlo,w
        movwf   L_byte

        movf    H_begin,w
        movwf   H_mulplr
        movf    L_begin,w
        movwf   L_mulplr
;
;---------------------------------------------
;  24 - 16- 
;---------------------------------------------
; LMH_byte(24bits)-LH_mulplr(16 bits) -> LMH_byte(24bits)
;
d_sub   call    negative  ;   
;
;---------------------------------------------
;  24 + 16- 
;---------------------------------------------
; LMH_byte(24bits)+LH_mulplr(16 bits) -> LMH_byte(24bits)
;
d_add   movf    L_mulplr,w
        addwf   L_byte,f
        btfsc   status,0
        incf    M_byte,f
        movf    H_mulplr,w
        addwf   M_byte,f
        btfsc   status,0
        incf    H_byte,f
        ret
;
negat
        comf    L_mulplr,f
        incf    L_mulplr,f
        btfsc   status,2
        decf    H_mulplr,f
        comf    H_mulplr,f
        ret
;
;---------------------------------------------
;   
;---------------------------------------------
sec_op
        movlw   LOW f09c
        call    read
        movwf   H_mulplr
;
        movlw   LOW (f09c + 1)
        call    read
        movwf   L_mulplr
        ret

;
;---------------------------------------------
;   
;---------------------------------------------
key_off
        movf    port_b,w   ; port_b  W
        andlw   8f         ;  
        xorlw   8f         ;  ?
        jnz     key_off
        ret
;
;---------------------------------------------
; 
;---------------------------------------------
wait1
        movlw   10         ;
        movwf   count1     ;
loop2                      ;
        movlw   0xFF       ;
        movwf   count      ;
loop1                      ;
        decfsz  count,f    ; ()
        goto    loop1      ;
                           ;
        decfsz  count1,f   ;
        goto    loop2      ;
        ret
;
;---------------------------------------------
;    EEPROM
;---------------------------------------------
;
wrtpar
        bcf     IntCon,7  ; 

        movf    param,w   ; 
        jz      wrt1
        movwf   L_mulplr
        movlw   0
        movwf   H_mulplr
        movlw   5
        movwf   mulcnd    ;  -    (5)
        call    m16x8

        movf    L_byte,w
wrt1
        movwf   count2

        movwf   EEAdr
        movf    H_konf,w
        call    wrp

        incf    count2,f
        movf    count2,w

        movwf   EEAdr
        movf    M_konf,w
        call    wrp

        incf    count2,f
        movf    count2,w

        movwf   EEAdr
        movf    L_konf,w
        call    wrp

        call    divide

        incf    count2,f
        movf    count2,w

        movwf   EEAdr
        movf    M_konf,w
        call    wrp

        incf    count2,f
        movf    count2,w

        movwf   EEAdr
        movf    L_konf,w
wrp
        movwf   EEData
        bsf     status,RP0
        bsf     EECon1,2    ;  
        movlw   055h
        movwf   EECon2
        movlw   0AAh
        movwf   EECon2
        bsf     EECon1,1
wr1
        btfss   EECon1,4
        goto    wr1
        bcf     EECon1,4
        bcf     status,RP0

        ret
;=============================================
;************ MAIN PROGRAM *******************
;=============================================
start
        bsf     status,5
        movlw   0
        movwf   01h
        clrw
        movwf   port_a
        movlw   08Fh
        movwf   port_b
        bcf     status,5
;---------------------------------------------
; 
;---------------------------------------------
init
        movlw   2        ;
        movwf   count1   ;
init2                    ;
        movlw   0xFF     ;
        movwf   count    ;HT1610
init1                    ;
        decfsz  count,f  ;
        goto    init1    ;
                         ;
        decfsz  count1,f ;
        goto    init2    ;
init3
        movlw   8        ;
        movwf   fsr      ;
clear                    ;
        clrf    indf     ;
        incf    fsr,f    ;
        btfss   fsr,5    ;
        goto    clear    ;
;
        clrf    fsr      ; 0 
;           

        movlw   LOW f1c     ;
        call    read
        movwf   H_begin
;
        movlw   LOW (f1c + 1)
        call    read
        movwf   L_begin

        movlw   LOW f2c     ;
        call    read
        movwf   H_end
;
        movlw   LOW (f2c + 1)
        call    read
        movwf   L_end
;              ; 
        movlw   LOW f3c
        call    read
        movwf   txhi           ;
        movwf   M_byte
;
        movlw   LOW (f3c + 1)
        call    read
        movwf   txlo
        movwf   L_byte
;                
        call    secoper
;              
        call    dsub
        movf    L_byte,w
        movwf   rxlo
        movf    M_byte,w
        movwf   rxhi
;
        movlw   LOW (f11c+1)  ;
        call    read
        movwf   step          ;
        movf    step,f
        jnz     st1
        movlw   1
        movwf   step
st1
        bcf     status,0    ; cary
        rlf     step,w
        movwf   step4        ; 
        rlf     step4,f
;
        movlw   LOW (f11 + 2)
        call    read
        movwf   realst      ; 
;
        goto    hotstart
;
; 
begin
        movf    port_b,w   ; port_b  W
        andlw   8f         ;  
        xorlw   8f         ;  ?
        jz      begin
;
        call    wait
;
;                
        movf    port_b,w   ; port_b  W
        andlw   8f         ;  
        xorlw   8f         ;  ?
        jz      begin
;
;    ----------------------
        movf    port_b,w   ;  port_b  W
        movwf   rotate     ;  rotate
        andlw   0x03
        jz      retrans1

        movf    rotate,w
        andlw   0x0c
        jz      setup

        rlf     rotate,w
        jnc     transmit

        rrf     rotate,f
        jnc     pl25

        rrf     rotate,f
        jnc     mn25

        rrf     rotate,f
        jnc     pl100

        call    minus100   ; 100 
hotstart
        call    sound      ;
hst
        bsf     port_a,3   ; 
        bcf     EECon1,2   ;   EEPROM
        movlw   rxhi       ; 
        movwf   count1     ;
        call    setfreq    ; 
;      

        call    secoper
;
        movf    rxlo,w     ;  
        addwf   L_mulplr,f ;( - )/5
        jnc     hot1
        incf    H_mulplr,f
hot1
        movf    rxhi,w
        addwf   H_mulplr,f
hot2
        movlw   HStep
        movwf   mulcnd  ;  5
        call    m16x8
        call    b2_bcd  ;  .- 
;           HT1610
;
;                           
        movf    cross,w ; 
        call    displ   ;
        movlw   0       ; 
        call    displ   ;
        movf    R0,w    ; 
        call    displ   ;
        movf    R1,w    ;
        call    displ   ;
        movf    R2,w    ;
        call    displ   ;
                        ;  
        call    keyoff
;
        movlw   10
        movf    count1,f
koff2
        movlw   0xFF
        movf    count,f
koff1
        decfsz  count,f
        goto    koff1

        decfsz  count1,f
        goto    koff2

        goto    begin
;
retrans1                   ; on/off
        call    retrans
        goto    hotstart
;
pl25                       ; 25 
        call    plus25
        goto    hotstart
;
mn25                       ; 25 
        call    minus25
        goto    hotstart
;
pl100                      ; 100 
        call    plus100
        goto    hotstart
;
transmit
        bcf     port_a,3   ; 
        movlw   txhi       ; 
        movwf   count1     ;
        call    setfreq    ; 
;
        movf    txlo,w     ; 
        movwf   L_mulplr
        movf    txhi,w
        movwf   H_mulplr
;
        movlw   HStep
        movwf   mulcnd    ;  5
        call    m16x8
        call    b2_bcd    ;  .- 
;           HT1610
;          
        movf    cross,w ; 
        call    displ
;
        movlw   0       ; 
        call    displ
;
        movf    R0,w    ; 
        call    displ
        movf    R1,w
        call    displ
        movf    R2,w
        call    displ
            ;  
        call    keyoff

        movlw   10
        movf    count1,f
koff12
        movlw   0xFF
        movf    count,f
koff11
        decfsz  count,f
        goto    koff11

        decfsz  count1,f
        goto    koff12
;
        goto    hst
;---------------------------------------------
;  
;---------------------------------------------
setup
;
        clrf    param
loadpar
        clrf    konf2
        movlw   0B0h
        movwf   konf1

        clrf    H_byte
        clrf    M_byte
        movf    param,w  ; 
        movwf   L_byte
        incf    L_byte,f

        call    b2_bcd  ;   
        swapf   R2,w
        andlw   0Fh
        iorwf   konf1,f
        swapf   R2,w
        andlw   0F0h
        iorwf   konf2,f

        movf    param,w   ; 
        movwf   L_mulplr
        movlw   0
        movwf   H_mulplr
        movlw   5
        movwf   mulcnd  ;  -    (5)
        call    m16x8

        movf    L_byte,w
        movwf   count

        call    read
        movwf   H_konf

        incf    count,f

        movf    count,w
        call    read
        movwf   M_konf

        incf    count,f

        movf    count,w
        call    read
        movwf   L_konf
parloop
        movf    H_konf,w
        movwf   H_byte
        movf    M_konf,w
        movwf   M_byte
        movf    L_konf,w
        movwf   L_byte

        call    b2_bcd

        movf    konf1,w
        call    displ
        movf    konf2,w
        call    displ   ;
        movf    R0,w    ; 
        call    displ   ;
        movf    R1,w    ;
        call    displ   ;
        movf    R2,w    ;
        call    displ   ;

        call    keyoff

;   
keyloop
        movf    port_b,w   ; port_b  W
        andlw   8f         ;  
        xorlw   8f         ;  ?
        jz      keyloop

        call    wait
;
;                
        movf    port_b,w   ; port_b  W
        andlw   8f         ;  
        xorlw   8f         ;  ?
        jz      keyloop

        call    sound

        movf    port_b,w   ;  port_b  W
        movwf   rotate     ;  rotate

        movf    rotate,w
        andlw   0x0c
        jz      cold1

        rrf     rotate,f
        jnc     incpar

        rrf     rotate,f
        jnc     decpar

        rrf     rotate,f
        jnc     nextpar

        rrf     rotate,f
        jnc     prevpar
        goto    keyloop

decpar
        movlw   8
        subwf   param,w
        jnc     dec1
        movlw   5
        goto    dec2
dec1
        movf    realst,w
dec2
        subwf   L_konf,f
        jc      parloop
        movlw   1
        subwf   M_konf,f
        jc      parloop
        decf    H_konf,f
        goto    parloop

incpar
        movlw   8
        subwf   param,w
        jnc     inc1
        movlw   5
        goto    inc2
inc1
        movf    realst,w
inc2
        addwf   L_konf,f
        jnc     parloop
        movlw   1
        addwf   M_konf,f
        jnc     parloop
        incf    H_konf,f
        goto    parloop
;
nextpar
        call    writepar

        incf    param,f
        movlw   .12
        subwf   param,w
        jz      nextpar1
        goto    loadpar
nextpar1
        clrf    param
        goto    loadpar
;
prevpar
        call    writepar

        movf    param,f
        jz      prevpar1
        decf    param,f
        goto    loadpar
prevpar1
        movlw   .11
        movwf   param
        goto    loadpar
;
cold1
        call    writepar

        call    keyoff
        goto    cold
;
;=============================================
;************ END PROGRAM ********************
;=============================================
;
        end
